; This CSD uses all MIDI UDOs supplied, but is not (yet) a real demonstration.
; It uses the rtmidi ALSA system and a samplerate of 48000Hz.
<CsoundSynthesizer>
<CsOptions>
-o dac -d --messagelevel=2
-Ma -+rtmidi=alsa
</CsOptions>
; ==============================================
<CsInstruments>

sr	=	48000
ksmps	=	1
nchnls	=	2
0dbfs	=	1

#include "m_midi_pitchbend.udo"
#include "m_midi_ratio.udo"
#include "m_rtmidi_freq.udo"
#include "m_midi_freq.udo"

;massign -1, -1

instr Play
	kRatIndex = linsegr:k(0, 2, 4, .1, 4)
	kRatio = m_midi_ratio(kRatIndex, 1/3, 2)
	kFreq = m_rtmidi_freq(0,0,kRatio)

	; Audio stuff
	kAmp = linsegr(0, .01, .2, .1, 0)
	aOut = oscil(kAmp,kFreq,-1)
	outs(aOut, aOut)
endin

instr Other
	kStat, kChan, kD1, kD2 midiin
	kNote init 0
	kBend init 0
	kAmp init 0
	kGate init 0
	kCount init 0
	kRatIndex = oscil(2,.3,-1)
	kRatIndex += 2
	kRatio = m_midi_ratio(kRatIndex,1/3,2)

	if (kStat == 144) then
		kNote = kD1
		kGate = .2
		kCount += 1
	elseif (kStat == 128) then
		kCount -= 1
		if (kCount == 0) then
			kGate = 0
		endif
	elseif (kStat == 224) then
		kBend = m_midi_pitchbend(kD1, kD2)
	endif
	kAmp = port(kGate, .01)
	kFreq = m_midi_freq(kNote,kBend,0,0,kRatio,-1,2,12)
	aOut = oscil(kAmp, kFreq, -1)
	outs(aOut, aOut)
endin

instr Test
	kStat, kChan, kD1, kD2 midiin
	kVal init 0
	if (kStat == 224) then
		kVal = kD2 * 128 + kD1 - 8192
		printks("\nbend %d", 1/kr, kVal)
	endif
endin

</CsInstruments>
; ==============================================
<CsScore>
f0 3600
;i"Other" 0 60
;i"Test" 0 60
e
</CsScore>
</CsoundSynthesizer>
